unit Sample;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Buttons, Grids, DBGrids, Kldbgrid, StdCtrls;

var
  LeftProc1, LeftProc2 : TLeftBtnClickEvent;
  RightProc1, RightProc2 : TRightBtnClickEvent;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    Table1SpeciesNo: TFloatField;
    Table1Category: TStringField;
    Table1Common_Name: TStringField;
    Table1SpeciesName: TStringField;
    Table1Lengthcm: TFloatField;
    Table1Length_In: TFloatField;
    Table1Notes: TMemoField;
    Table1Graphic: TGraphicField;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;   
    DataSource2: TDataSource;
    Table2: TTable;
    Table2LAST_NAME: TStringField;
    Table2FIRST_NAME: TStringField;
    Table2ACCT_NBR: TFloatField;
    Table2ADDRESS_1: TStringField;
    Table2CITY: TStringField;
    Table2STATE: TStringField;
    Table2ZIP: TStringField;
    Table2TELEPHONE: TStringField;
    Table2DATE_OPEN: TDateField;
    Table2SS_NUMBER: TFloatField;
    Table2PICTURE: TStringField;
    Table2BIRTH_DATE: TDateField;
    Table2RISK_LEVEL: TStringField;
    Table2OCCUPATION: TStringField;
    Table2OBJECTIVES: TStringField;
    Table2INTERESTS: TStringField;
    Table2IMAGE: TBlobField;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    KLDBGrid1: TKLDBGrid;
    KLDBGrid2: TKLDBGrid;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure KLDBGrid1LeftBtnClick(GridName, FieldName: string;
      Col: Longint; var ReturnCode: Boolean);
    procedure KLDBGrid1RightBtnClick(GridName, FieldName: string;
      Col: Longint; var ReturnCode: Boolean);
    procedure KLDBGrid2LeftBtnClick(GridName, FieldName: string;
      Col: Longint; var ReturnCode: Boolean);
    procedure KLDBGrid2RightBtnClick(GridName, FieldName: string;
      Col: Longint; var ReturnCode: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}



procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
CheckBox1.Checked := True;
CheckBox2.Checked := False;
CheckBox2.Enabled := False;
CheckBox3.Checked := True;
KLDbGrid1.DrawBmpInGrid := True;
KLDbGrid1.MakeIndexEnabled := False;
KLDbGrid1.ShowObjectsHint := True;
KLDbGrid1.SortDescEnable := False;
Table1.Open;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
CheckBox1.Checked := True;
CheckBox2.Enabled := True;
CheckBox2.Checked := True;
CheckBox3.Checked := True;
KLDbGrid1.DrawBmpInGrid := True;
KLDbGrid1.MakeIndexEnabled := True;
KLDbGrid1.ShowObjectsHint := True;
Table1.Exclusive := True;
Table1.Open;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
Table1.Close;
CheckBox1.Checked := False;
CheckBox2.Checked := False;
CheckBox2.Enabled := True;
CheckBox3.Checked := False;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
KLDbGrid1.DrawBmpInGrid := CheckBox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
KLDbGrid1.MakeIndexEnabled := CheckBox2.Checked;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
KLDbGrid1.ShowObjectsHint := CheckBox3.Checked;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
CheckBox4.Checked := True;
CheckBox5.Enabled := False;
CheckBox5.Checked := False;
CheckBox6.Checked := True;
CheckBox7.Enabled := False;
CheckBox7.Checked := False;
KLDbGrid2.DrawBmpInGrid := True;
KLDbGrid2.MakeIndexEnabled := False;
KLDbGrid2.ShowObjectsHint := True;
KLDbGrid2.SortDescEnable := False;
Table2.Open;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
CheckBox4.Checked := True;
CheckBox5.Enabled := True;
CheckBox5.Checked := True;
CheckBox6.Checked := True;
CheckBox7.Enabled := True;
CheckBox7.Checked := True;
KLDbGrid2.DrawBmpInGrid := True;
KLDbGrid2.MakeIndexEnabled := True;
KLDbGrid2.ShowObjectsHint := True;
KLDbGrid2.SortDescEnable := True;
Table2.Exclusive := True;
Table2.Open;
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
Table2.Close;
CheckBox4.Checked := False;
CheckBox5.Checked := False;
CheckBox5.Enabled := True;
CheckBox6.Checked := False;
CheckBox7.Enabled := True;
CheckBox7.Checked := False;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
KLDbGrid2.DrawBmpInGrid := CheckBox4.Checked;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
KLDbGrid2.MakeIndexEnabled := CheckBox5.Checked;
end;

procedure TForm1.CheckBox6Click(Sender: TObject);
begin
KLDbGrid2.ShowObjectsHint := CheckBox6.Checked;
end;

procedure TForm1.CheckBox7Click(Sender: TObject);
begin
KLDbGrid2.SortDescEnable := CheckBox7.Checked;
end;

procedure TForm1.KLDBGrid1LeftBtnClick(GridName, FieldName: string;
  Col: Longint; var ReturnCode: Boolean);
begin
messageDlg('USER DEFINED PROCEDURE SAMPLE' + Chr(10) + Chr(13) +
           Chr(10) + Chr(13) +
           'You clixked the LEFT side button' + Chr(10) + Chr(13) +
           'of ' + GridName + ' above ' + FieldName ,mtInformation,[mbOK],0);
ReturnCode := CheckBox9.Checked;
end;

procedure TForm1.KLDBGrid1RightBtnClick(GridName, FieldName: string;
  Col: Longint; var ReturnCode: Boolean);
begin
messageDlg('USER DEFINED PROCEDURE SAMPLE' + Chr(10) + Chr(13) +
           Chr(10) + Chr(13) +
           'You clixked the RIGHT side button' + Chr(10) + Chr(13) +
           'of ' + GridName + ' above ' + FieldName ,mtInformation,[mbOK],0);
ReturnCode := CheckBox9.Checked;
end;

procedure TForm1.KLDBGrid2LeftBtnClick(GridName, FieldName: string;
  Col: Longint; var ReturnCode: Boolean);
begin
messageDlg('You clixked the LEFT side button' + Chr(10) + Chr(13) +
            'of ' + GridName + ' above ' + FieldName ,mtInformation,[mbOK],0);
ReturnCode := False;
end;

procedure TForm1.KLDBGrid2RightBtnClick(GridName, FieldName: string;
  Col: Longint; var ReturnCode: Boolean);
begin
messageDlg('You clixked the RIGHT side button' + Chr(10) + Chr(13) +
            'of ' + GridName + ' above ' + FieldName ,mtInformation,[mbOK],0);
ReturnCode := False;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LeftProc1 := KLDBGrid1LeftBtnClick;
  LeftProc2 := KLDBGrid2LeftBtnClick;
  RightProc1 := KLDBGrid1RightBtnClick;
  RightProc2 := KLDBGrid2RightBtnClick;
end;

procedure TForm1.CheckBox8Click(Sender: TObject);
begin
if not CheckBox8.Checked then
  begin
    CheckBox9.Checked := False;
    CheckBox9.Enabled := False;
    KLDbGrid1.onLeftBtnClick := nil;
    KLDbGrid1.onRightBtnClick := nil;
  end
else
  begin
    CheckBox9.Enabled := True;
    KLDbGrid1.onLeftBtnClick := LeftProc1;
    KLDbGrid1.onRightBtnClick := RightProc1;
  end;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
WinExec('winhelp.exe kldbgrid.hlp', SW_SHOW);
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
KLDbGrid1.RightButtonPopupUserItem := Edit1.Text;
end;

end.
